#!/bin/bash

declare -a polygon_x  # массив координат X
declare -a polygon_y  # массив координат Y
square=0
S=4                   # число знаков в вычислениях

function triangle {   # расчёт единичного треугольника
   declare -a side    # длины сторон треугольника [1...3]
   beg=$1             # номер начальной вершины [1...]
   perimeter="0.0"
   for (( j=$beg; j<=$beg+2; j++ ))     # двойные круглые скобки и "j" без "$".
   do
      if [[ j -eq $beg ]]  
      then k=$beg+2
      else k=$j-1
      fi
      side[$j-$beg+1]=$(echo "scale=$S; sqrt((${polygon_x[j]}-${polygon_x[$k]})^2+\
                                             (${polygon_y[j]}-${polygon_y[$k]})^2)" | bc)
      perimeter=$(echo "scale=$S; $perimeter+${side[$j-$beg+1]}" | bc)
   done
   square=$(echo "scale=$S; $perimeter/2" | bc)
   for (( j=1; j<=3; j++ ))             # двойные круглые скобки и "j" без "$".
   do
      square=$(echo "scale=$S; $square*($perimeter/2-${side[$j]})" | bc)
   done
   square=$(echo "scale=$S; sqrt($square)" | bc)
}


while [ TRUE ]
do
   i=1
   echo "координаты вершин в формате: X Y (^D конец ввода)"
   polygon_x=()
   polygon_y=()
   while [ TRUE ]
   do
      echo -n "вершина № $i : "
      declare -a parm
      read -a parm
      element_count=${#parm[@]}       # число введенных значений
      if [[ $element_count -eq 0 ]]   # ^D - конец ввода
      then
         echo -en "\r\a"
         break
      elif [[ $element_count -ne 2 ]] # неправильное число элементов ввода
      then
         echo "ошибка ввода!"
         continue
      fi
      polygon_x[ $i ]=${parm[0]}
      polygon_y[ $i ]=${parm[1]}
      i=`expr $i + 1`   
   done
   size=${#polygon_x[@]}              # размерность многоугольника 
   polystr=""   
   for (( j=1; j<=$size; j++ ))       # двойные круглые скобки и "j" без "$".
   do
      polystr="$polystr [${polygon_x[$j]},${polygon_y[$j]}] "
   done
   echo "вершин $size : $polystr"
   length=0
   for (( j=1; j<=$size; j++ ))       # двойные круглые скобки и "j" без "$".
   do
      if [[ j -eq 1 ]]  
      then k=$size
      else k=$j-1
      fi
      length=$(echo "scale=$S; $length+sqrt((${polygon_x[j]}-${polygon_x[$k]})^2+\
                                           (${polygon_y[j]}-${polygon_y[$k]})^2)" | bc)
   done
   echo "периметр = $length"
   pole=0
   for (( m=1; m<$size-1; m++ ))       # двойные круглые скобки и "j" без "$".
   do
      triangle $m
      pole=$(echo "scale=$S; $pole+$square" | bc)
   done
   echo "площадь = $pole"
   echo ---------------------------------
done
