#!/usr/bin/python
# -*- coding: utf-8 -*-

import math
from polygon import *

def square( pts ):
    summa = 0.0;
    for i in range( len( pts ) - 2 ):
        n1, p1 = cmath.polar( pts[ i + 1 ] - pts[ 0 ] )
        n2, p2 = cmath.polar( pts[ i + 2 ] - pts[ 0 ] )
        summa += n1 * n2 * abs( math.sin( p2 - p1 ) ) / 2.
    return summa

print( "{:.2f}".format( square( polygon( instr() ) ) ) )
quit( 0 )

