#!/bin/bash

declare -a polygon_x
declare -a polygon_y

while [ TRUE ]
do
   i=1
   echo "координаты вершин в формате: X Y (^D конец ввода)"
   polygon_x=()
   polygon_y=()
   while [ TRUE ]
   do
      echo -n "вершина № $i : "
      declare -a parm
      read -a parm
      element_count=${#parm[@]}       # число введенных значений
      if [[ $element_count -eq 0 ]]   # ^D - конец ввода
      then
         echo -en "\r\a"
         break
      elif [[ $element_count -ne 2 ]] # неправильное число элементов ввода
      then
         echo "ошибка ввода!"
         continue
      fi
      polygon_x[ $i ]=${parm[0]} 
      polygon_y[ $i ]=${parm[1]}
      i=`expr $i + 1`   
   done
   size=${#polygon_x[@]}              # размерность многоугольника 
   polystr=""   
   for (( j=1; j<=$size; j++ ))       # двойные круглые скобки и "j" без "$".
   do
      polystr="$polystr [${polygon_x[j]},${polygon_y[j]}] "
   done                     
   echo "вершин $size : $polystr"
   cmd="./perimeter.py \" $polystr \""
   ret=`eval $cmd`
   echo "периметр = $ret"
   cmd="./square.py \" $polystr \""
   ret=`eval $cmd`
   echo "площадь = $ret"
   echo ---------------------------------
done
