import java.io.*;
import java.util.StringTokenizer;
import java.lang.Double.*;

/* class Complex заимствуется из отдельного файла */

class Tric {        // класс треугольник
   public static final int nodes = 3;
   Complex [] pt = new Complex[ nodes ];
   public String toString()  {
       String ret = "";
       for( int i = 0; i < nodes; i++ ) 
          ret += "[" + ( new Double( pt[ i ].re ) ).toString() + "," +
                       ( new Double( pt[ i ].im ) ).toString() + "] ";
       return ret;
   }
   public double perimeter() {
      double summa = 0.0;
      for( int i = 0; i < nodes; i++ ) 
         summa += pt[ i ].minus( pt[ nodes - 1 == i ? 0 : i + 1 ] ).r();
      return summa;
   }
   public double square() {
      Complex side1 = pt[ 1 ].minus( pt[ 0 ] ),
              side2 = pt[ 2 ].minus( pt[ 0 ] );
      return side1.r() * side2.r() *
             Math.abs( Math.sin( side1.theta() - side2.theta() ) ) / 2.; 
   }
}

public class triangle {
   public static void main( String[] args ) {
      Console cons = System.console();
      while( true ) { 
         String szStr = "";
         Tric polygon = new Tric();
         System.out.println( "координаты вершин в формате: X Y" );
         for( int i = 0; i < Tric.nodes; ) {
            szStr = cons.readLine( "%s%d%s", "вершина № ", i + 1, " : " );
            if( null == szStr ) {          // ^D
               System.out.println( "завершение работы" );
               System.exit( 0 );
            }
            StringTokenizer st = new StringTokenizer( szStr, " \r\n" );
            try {
               double x = ( new Double( (String)st.nextElement() ) ).doubleValue(),
                      y = ( new Double( (String)st.nextElement() ) ).doubleValue();
               polygon.pt[ i ] = new Complex( x, y );
            }
            catch( java.util.NoSuchElementException ex ) {
               System.out.println( "ошибка ввода!: " + ex.toString() ); 
               continue;
            }
            catch( java.lang.NumberFormatException ex ) {
               System.out.println( "ошибка ввода!: " + ex.toString() ); 
               continue;
            }
            i++;
         }
         System.out.println( "вершин " + Tric.nodes + " : " + polygon.toString() ); 
         System.out.println( "периметр = " + polygon.perimeter() );
         System.out.println( "площадь = " + polygon.square() );
         System.out.println( "---------------------------------" );
      }
   }
}

// http://docs.oracle.com/javase/6/docs/api/java/util/regex/Pattern.html
